/* The Computer Language Shootout
   http://shootout.alioth.debian.org
   Contributed by Gavin Harrison */

System args := list("test", "5")

times := System args at(1) asNumber

sum := 0

MyThread := Object clone do(
    init := method(
        "init" println
        self coro := Coroutine clone
        coro setStackSize(15000)
        coro setRunTarget(self) setRunLocals(self)
        coro setRunMessage(message(process))
        coro setParentCoroutine(Coroutine currentCoroutine)
        coro run
    )

    step := method(
        coro setParentCoroutine(Coroutine currentCoroutine)
        coro resume
    )

    process := method(
        coro resumeParentCoroutine
        for(n, 1, 5,
            n println
            coro resumeParentCoroutine
        )
    )
)

last := nil
print

mainCoro := Coroutine currentCoroutine
t := MyThread clone
//Collector setDebug(true)
5 repeat(t step)
print


buf := read("test.io", 20)
buf println
buf atPut(0, 40)
buf println
"Hoge" println
Hoge println
h println
h i println
//hige := Hoge clone
h setI(60000)
h println
h show
hogefun(h)

Fuga print
f := Fuga clone
Fuga show
f show


/*
times := System args at(1) asNumber
sum := 0
n := 0

send := method(
	if(n > 1,
		n = n - 1
		coro := Coroutine clone setStackSize(20000)
		coro setRunTarget(Lobby)
		coro setRunLocals(Lobby)
		coro setRunMessage(message(send))
		coro run
	, Lobby sum = sum + 500; mainCoro resume)
)
mainCoro := Coroutine currentCoroutine

iters := System args at(1) asNumber
for(i, 1, iters,
	n = 500
	send
	//writeln("iter ", i,  "\t", sum, "\t", (Collector maxAllocatedBytes/1000000) asString(0,2))
	//Collector collect
)
writeln(sum)
*/
